#include <SDL.h>

#include <string>

using namespace std;

#include "sprite.h"
#include "utils.h"
#include "rendermanager.h"


void Sprite::init()
{
	if(img==NULL)
		img=LoadImgAlpha(name);

}

void Sprite::activate()
{
	rect=owner->getRect();
	rect.w=get_w();
	rect.h=get_h();

	g->rendermanager->addToDraw(rect);
}

void Sprite::update()
{
	if(rect.x!=owner->getRect().x || 
		rect.y!=owner->getRect().y ||
		actual_tick>max_tick)
	{
		if(actual_tick>max_tick)
		{
			actual_tick=0;
			actual_frame++;
			if(actual_frame>=num_frames)
				actual_frame=0;
		} 

		//Poner el fondo donde estaba antes
		g->rendermanager->addToDraw(rect);

		rect=owner->getRect();
		rect.w=get_w();
		rect.h=get_h();

		//Poner el fondo donde va a estar ahora
		g->rendermanager->addToDraw(rect);
	}
	actual_tick++;
}

void Sprite::desactivate()
{
	g->rendermanager->addToDraw(rect);
}

void Sprite::draw()
{
	SDL_Rect a={get_w()*actual_frame,0,get_w(),get_h()};
	SDL_Rect r=rect;
	SDL_BlitSurface(img,&a,SDL_GetVideoSurface(),&r);
}
